def two_times
  yield
  yield
end
count = 0
two_times { count += 1 }
puts count

def fib_up_to(max)
  i1, i2 = 1, 1 # Паралельное присваивание
  while i1 <= max
    yield(i1)
    i1, i2 = i2, i1+i2
  end
end
fib_up_to(1000) {|f| print f, " "}
puts

require 'pry'
#binding.pry

class Array
  def find # Вариант реализации find
    each do |value|
      result = yield(value)
      if result
        return value
      end
    end
    nil
  end
end
arr = [1, 3, 5, 7, 9]
res = arr.find do |v|
  v*v > 30 # => 7
end
puts res
res = arr.find do |value|
  (value / 2.0) > 2
end
puts res