text = <<~DOC
mama milA ramy
mama Mila rAmi
mama milA raMy
mima miLa remY
ramy mIla mima
o'connel own's
DOC

def words_from_string(string)
  string.downcase.scan(/[\w']+/)
end

word_list = words_from_string(text)
counts = Hash.new(0)
for word in word_list
  counts[word] += 1
end

sorted = counts.sort_by {|_, count| count}

top_five = sorted.last(5)
top_five.each do |word, count|
  puts "#{word} : #{count}"
end
